#lang racket/base

(require "api.rkt")

(provide (all-defined-out))

(define test-soa-rr
  (rr (domain '(#"example")) 'soa 'in 30
      (soa (domain '(#"ns" #"example"))
	   (domain '(#"tonyg" #"example"))
	   1
	   24
	   24
	   30
	   10)))

(define test-rrs
  (list (rr (domain '(#"localhost" #"example")) 'a 'in 30 '#(127 0 0 1))
	(rr (domain '(#"example")) 'mx 'in 30 (mx 5 (domain '(#"localhost" #"example"))))
	(rr (domain '(#"example")) 'mx 'in 30 (mx 10 (domain '(#"subns" #"example"))))
	(rr (domain '(#"google" #"example")) 'cname 'in 30 (domain '(#"www" #"google" #"com")))
	(rr (domain '(#"roar" #"example")) 'a 'in 30 '#(192 168 1 1))
	(rr (domain '(#"alias" #"example")) 'cname 'in 30 (domain '(#"roar" #"example")))
	(rr (domain '(#"ns" #"example")) 'a 'in 30 '#(127 0 0 1))
	(rr (domain '(#"hello" #"example")) 'txt 'in 30 '(#"Hello CRASH"))
	(rr (domain '(#"subzone" #"example")) 'ns 'in 30 (domain '(#"subns" #"example")))
	(rr (domain '(#"subns" #"example")) 'a 'in 30 '#(127 0 0 2))))

;; (define test-roots
;;   (list (rr (domain '()) 'ns 'in 30 (domain '(#"f" #"root-servers" #"net")))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(198 41 0 4))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 228 79 201))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 33 4 12))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 203 230 10))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 112 36 4))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(128 63 2 53))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(192 58 128 30))
;; 	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 30 '#(193 0 14 129))))

(define test-roots
  (list (rr (domain '(#"a" #"root-servers" #"net")) 'a 'in 3600000 '#(198 41 0 4))
	(rr (domain '(#"b" #"root-servers" #"net")) 'a 'in 3600000 '#(192 228 79 201))
	(rr (domain '(#"c" #"root-servers" #"net")) 'a 'in 3600000 '#(192 33 4 12))
	(rr (domain '(#"d" #"root-servers" #"net")) 'a 'in 3600000 '#(128 8 10 90))
	(rr (domain '(#"e" #"root-servers" #"net")) 'a 'in 3600000 '#(192 203 230 10))
	(rr (domain '(#"f" #"root-servers" #"net")) 'a 'in 3600000 '#(192 5 5 241))
	(rr (domain '(#"g" #"root-servers" #"net")) 'a 'in 3600000 '#(192 112 36 4))
	(rr (domain '(#"h" #"root-servers" #"net")) 'a 'in 3600000 '#(128 63 2 53))
	(rr (domain '(#"i" #"root-servers" #"net")) 'a 'in 3600000 '#(192 36 148 17))
	(rr (domain '(#"j" #"root-servers" #"net")) 'a 'in 3600000 '#(192 58 128 30))
	(rr (domain '(#"k" #"root-servers" #"net")) 'a 'in 3600000 '#(193 0 14 129))
	(rr (domain '(#"l" #"root-servers" #"net")) 'a 'in 3600000 '#(199 7 83 42))
	(rr (domain '(#"m" #"root-servers" #"net")) 'a 'in 3600000 '#(202 12 27 33))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"a" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"b" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"c" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"d" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"e" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"f" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"g" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"h" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"i" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"j" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"k" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"l" #"root-servers" #"net")))
	(rr (domain '()) 'ns 'in 3600000 (domain '(#"m" #"root-servers" #"net")))))

(define pathological-roots
  (list (rr (domain '(#"a")) 'ns 'in 30 (domain '(#"ns" #"b")))
	(rr (domain '(#"b")) 'ns 'in 30 (domain '(#"ns" #"a")))))

(define (test-port-number)
  (string->number
   (or (getenv "DNSPORT")
       (error 'test-port-number "Please set your DNSPORT environment variable."))))
